#===============================================================================
# Ttulo: Intriduo a Estatstica
# Autor : Jos Cludio Faria
# Data  : 06/01/2023 08:56:07
# Objetivos: Teorema Central no limite ou Teorema do limite Cental
#===============================================================================
# Pacote necessrio: fdth
#===============================================================================

#..___Ini opes___
# Pop
Mpop <- 10     # Mdia da pop
Vpop <-  4     # Varincia da pop

# Amo
n1  <-    2    # Tamanho da amostra 1
n2  <-   10    # Tamanho da amostra 2
n3  <-   50    # Tamanho da amostra 3
nem <-  1e4    # Nmero de vezes que a mdia ser estimada (usar 1e3, ..., 1e5)
#..___Fim opes___

#. Simulao
pop <- rnorm(nem,
             mean=Mpop,
             sd=sqrt(Vpop))


em1 <- apply(matrix(rnorm(nem*n1,
                          mean=Mpop,
                          sd=sqrt(Vpop)),
                    ncol=n1),
             1, 
             mean)

em2 <- apply(matrix(rnorm(nem*n2,
                          mean=Mpop,
                          sd=sqrt(Vpop)),
                    ncol=n2),
             1, 
             mean)

em3 <- apply(matrix(rnorm(nem*n3,
                          mean=Mpop,
                          sd=sqrt(Vpop)),
                    ncol=n3),
             1,
             mean)

#. Plotar grficos
#.. Diagrama de disperso
x11(w=4, h=8)

op <- par(no.readonly=T)

par(mfcol=c(4, 1),
    oma=c(0, 1, 0, 1),
    mar=c(3, 2, 2, 2))

#... pop
mmY <- c(min(pop),
         max(pop))
plot(pop,
     main='pop',
     cex=2,
     pch='.',
     ylab='',
     xlab='',
     ylim=mmY)

abline(Mpop,
       0,
       col='red')

#... em1
plot(em1,
     main=paste('n =',
                n1),
     cex=1,
     col='red',
     pch='.',
     ylab='',
     xlab='',
     ylim=mmY)

abline(mean(em1),
       0)

#... em2
plot(em2,
     main=paste('n =',
                n2),
     cex=1, 
     col='orange',
     pch='.', 
     ylab='',
     xlab='',
     ylim=mmY)

abline(mean(em2), 0)

#... em3
plot(em3, 
     main=paste('n =',
                n3),
     cex=1, 
     col='blue',
     pch='.',
     ylab='',
     xlab='',
     ylim=mmY)

abline(mean(em3),
       0)

par(op, no.readonly=T)

#.. Histograma
x11(w=6, h=8)

op <- par(no.readonly=T)

par(mfcol=c(4, 1)
#    oma=c(0, 2, 0, 2),
#    mar=c(3, 4, 2, 2)
    )

xl <- c(0, 20)
yl <- c(0, 1.5)

library(fdth)
#... pop
plot(fdt(pop),
     type='d',
     main='pop',
     xlim=xl,
     ylim=yl,
     x.round=0,
     xlab='',
     ylab=''
)

#... em1
plot(fdt(em1),
     type='d',
     main=paste('n =',
                n1),
     xlim=xl,
     ylim=yl,
     x.round=0,
     xlab='',
     ylab=''
)

#... em2
plot(fdt(em2),
     type='d',
     main=paste('n =',
                n2),
     xlim=xl,
     ylim=yl,
     x.round=0,
     xlab='',
     ylab=''
)

#... em3
plot(fdt(em3),
     type='d',
     main=paste('n =',
                n3),
     xlim=xl,
     ylim=yl,
     x.round=0,
)

par(op, no.readonly=T)

#. Imprimir resultados numricos
cat('\n')
cat('pop:\n')
cat('M(pop)      = ', round(mean(pop), 2)); cat('\n')
cat('V(pop)      = ', round(var(pop), 2)); cat('\n\n')

cat('n1:\n')
cat('V(pop)/n1   = ', round((var(pop)/n1), 2)); cat('\n')
cat('s2(m1)      = ', round(var(em1), 2)); cat('\n\n')

cat('n2:\n')
cat('V(pop)/n2   = ', round((var(pop)/n2), 2)); cat('\n')
cat('s2(m2)      = ', round(var(em2), 2)); cat('\n\n')

cat('n3:\n')
cat('V(pop)/n3   = ', round((var(pop)/n3), 2)); cat('\n')
cat('s2(m2)      = ', round(var(em3), 2)); cat('\n\n')
