#===============================================================================
# Ttulo: Intriduo a Estatstica
# Autor : Jos Cludio Faria
# Data  : 09/12/2021 16:47:21
# Objetivos: Teorema Central no limite ou Teorema do limite Cental
#===============================================================================
# Pacote necessrio: lattice
#===============================================================================

#..___Ini opes___

Mpop <- 0           # Mdia da pop
Vpop <- 1           # Varincia da pop
N <- 1e4            # Nmero de elementos da pop

ns <- seq(1, 9, 1)  # Tamanhos das amostras a serem retiradas de pop
nem <- 100          # Nmero de vezes que a mdia ser estimada

#..___Fim opes___

require(lattice)   # requer lattice

#.. Gerar vetores armazenamento
amo <- numeric()   # Armazena a amostra
em  <- numeric()   # Armazena a estimativa da mdia da amostra
emf <- numeric()   # Armazena as estimativas finais da mdia das amostras

#.. Armazena nmero de nveis do tamanho da amostra
nn <- length(ns)

#.. Gera populao POP~N(Mpop, DPpop)
pop <- rnorm(N,
             mean=Mpop,
             sd=sqrt(Vpop))

#.. Loop para amostragem sequencial
for (i in 1:length(ns)) {
  for (j in 1:nem) {
    amo <- sample(pop,
                  ns[i],
                  r=T)
    em[j] <- mean(amo)  # Estima a mdia da pop
  }
  emf <- c(emf, em)     # Gera o vetor das estimativas
}

#.. Gera vetor dos tamanhos (n) das amostras
n <- gl(nn,
       nem,
       length=nn*nem,
       labels=paste("n =",
                    ns))

emf <- round(emf,
             3)

dF <- data.frame(emf,n)
names(dF) <- c('m', 'n')

x11(w=6,
    h=7) # Abre nova interface grfica (evitar sobreposio)

#.. As funes abaixo necessitam que o parmetro seja denominado 'x'
x <- emf

graf = densityplot(~ m | n, data=dF,
                    panel=function(x, ...)
                    {
                      panel.densityplot(x, col='DarkOliveGreen', ...)
                      panel.mathdensity(dmath=dnorm,
                                         args=list(mean=mean(x),
                                           sd=sd(x)),
                                          col='Blue')
                    })

print(graf)

cat('\n Estimativas da mdia e respectivos tamanhos da amostra:'); cat('\n')
print(df)

cat('\nValores considerados:'); cat('\n')
cat('  Populao:'); cat('\n')
cat('    Mdia =', Mpop); cat('\n')
cat('    Varincia =', Vpop); cat('\n')
cat('    N =', N); cat('\n')

cat('\nfdp de', nem,
    'estimativas da mdia (m) de cada tamanho (n)\n(n =', ns, ')',
    '\nda amostra:'); cat('\n\n')
    